/* will perform either interpolation or decimation.  You just have to 
   supply the proper filter.   p0 is output start, p1 is input duration
   p2 is input start, p3 is numerator, p4 is denominator p5 is number of
   sections, p6--> are coefficients */

#include "../H/ugens.h"
float ps[4][10],c[4][10],xnorm;
int   nsects;

interp(p,n_args)
float *p;
int n_args;
{
	long i,j,nsamps;
	float ellipse(),x,y;
	int num,denom,count;

	setnote(p[0],p[1]*p[3]/p[4],1);
	nsamps=setnote(p[2],p[1],0); /* nsamps is number of inputs to read*/

	num = p[3];
	denom = p[4];
	ellpset(p+5); 
	count = 1;
	for(i=0;i<nsamps;i++) {
		GETIN(&y,0); /* designed for one channel file right now */
		for(j=0;j<num;j++) {
			x=ellipse(y);
		        y = 0;
			if(count++ == denom) {
				ADDOUT(&x,1);
				count = 1;
				}
			}
		}
	endnote(1);
}

float ellipse(x)
float x;
{
	register int m;
	float op;

	for(m=0;m<nsects;m++) {
		op = x + c[0][m] * ps[0][m] + c[2][m] * ps[1][m]
		       - c[1][m] * ps[2][m] - c[3][m] * ps[3][m];
		ps[1][m] = ps[0][m];
		ps[0][m] = x;
		ps[3][m] = ps[2][m];
		ps[2][m] = op;
		x = op;
		}
	return(x*xnorm);
}

ellpset(list)
float *list;
{
/* the first argument in the list is the number of sections */
	int m,i,j;
	nsects = (int)list[0];
	i=1;
	for(m=0;m<nsects;m++) {
		for(j=0;j<4;j++)  {    
	        	 c[j][m] = list[i++];
			 ps[j][m] = 0; }
		}
	xnorm = list[i];
printf("xnorm %f \n",xnorm);
}
